package ru.dbotthepony.mc.otm.registry.data

import net.minecraft.core.registries.BuiltInRegistries
import net.minecraft.util.valueproviders.FloatProviderType
import net.minecraft.util.valueproviders.IntProviderType
import net.neoforged.bus.api.IEventBus
import ru.dbotthepony.mc.otm.data.world.OneOfFloatProvider
import ru.dbotthepony.mc.otm.data.world.OneOfIntProvider
import ru.dbotthepony.mc.otm.registry.MDeferredRegister

object MNumberProviders {
	private val floats = MDeferredRegister(BuiltInRegistries.FLOAT_PROVIDER_TYPE)
	private val ints = MDeferredRegister(BuiltInRegistries.INT_PROVIDER_TYPE)

	fun register(bus: IEventBus) {
		floats.register(bus)
		ints.register(bus)
	}

	val ONE_OF_FLOAT by floats.register("one_of_float") { FloatProviderType { OneOfFloatProvider.CODEC } }
	val ONE_OF_INT by ints.register("one_of_int") { IntProviderType { OneOfIntProvider.CODEC } }
}
