package ru.dbotthepony.mc.otm.registry.data

import net.minecraft.core.registries.BuiltInRegistries
import net.minecraft.world.level.levelgen.placement.PlacementModifierType
import net.neoforged.bus.api.IEventBus
import ru.dbotthepony.mc.otm.registry.MDeferredRegister
import ru.dbotthepony.mc.otm.registry.MRegistries
import ru.dbotthepony.mc.otm.server.world.feature.EnhancedFeature
import ru.dbotthepony.mc.otm.server.world.placement.ChainPlacement
import ru.dbotthepony.mc.otm.server.world.placement.EllipsoidPlacement
import ru.dbotthepony.mc.otm.server.world.placement.EnhancedChainPlacement
import ru.dbotthepony.mc.otm.server.world.placement.EnhancedCountPlacement
import ru.dbotthepony.mc.otm.server.world.placement.EnhancedSplitPlacement
import ru.dbotthepony.mc.otm.server.world.placement.SplitPlacement
import ru.dbotthepony.mc.otm.server.world.placement.WormPlacement

object MPlacementModifiers {
	private val registry = MDeferredRegister(BuiltInRegistries.PLACEMENT_MODIFIER_TYPE)
	private val enhancedRegistry = MDeferredRegister(MRegistries.PLACEMENT_MODIFIER)

	internal fun register(bus: IEventBus) {
		registry.register(bus)
		enhancedRegistry.register(bus)
	}

	val ELLIPSOID_PLACEMENT by registry.register("ellipsoid") { PlacementModifierType { EllipsoidPlacement.CODEC } }
	val WORM_PLACEMENT by registry.register("worm") { PlacementModifierType { WormPlacement.CODEC } }
	val SPLIT by registry.register("split") { PlacementModifierType { SplitPlacement.CODEC} }
	val CHAIN by registry.register("chain") { PlacementModifierType { ChainPlacement.CODEC } }

	init {
		enhancedRegistry.register("feature") { EnhancedFeature.ConfiguredWrapper.Companion }
		enhancedRegistry.register("ellipsoid") { EllipsoidPlacement.Companion }
		enhancedRegistry.register("worm") { WormPlacement.Companion }
		enhancedRegistry.register("split") { EnhancedSplitPlacement.Companion }
		enhancedRegistry.register("chain") { EnhancedChainPlacement.Companion }
		enhancedRegistry.register("count") { EnhancedCountPlacement.Companion }
	}
}
