package ru.dbotthepony.mc.otm.registry.data

import net.minecraft.core.registries.BuiltInRegistries
import net.neoforged.bus.api.IEventBus
import ru.dbotthepony.kommons.util.getValue
import ru.dbotthepony.mc.otm.registry.MDeferredRegister
import ru.dbotthepony.mc.otm.server.world.EnhancedPlacedFeature
import ru.dbotthepony.mc.otm.server.world.feature.BlackHolePlacerFeature
import ru.dbotthepony.mc.otm.server.world.feature.DebugPlacerFeature

object MWorldGenFeatures {
	private val registry = MDeferredRegister(BuiltInRegistries.FEATURE)

	internal fun register(bus: IEventBus) {
		registry.register(bus)
	}

	val BLACK_HOLE_PLACER by registry.register("black_hole_placer") { BlackHolePlacerFeature }
	val DEBUG_PLACEMENT by registry.register("debug") { DebugPlacerFeature }
	val ENHANCED_FEATURE by registry.register("enhanced_feature") { EnhancedPlacedFeature }
}
